static inline int
enter_critical_section ()
{
  int rv;
  rv = __builtin_rx_mvfc (0); /* PSW */
  __builtin_rx_mvtipl (15);
  return rv;
}

static inline int
leave_critical_section (int psw)
{
  __builtin_rx_mvtc (0, psw);
}

#define ENTER_CRITICAL_SECTION(var) var = enter_critical_section ()
#define LEAVE_CRITICAL_SECTION(var) leave_critical_section (var)
