#include <stdio.h>
#include "ports.h"
#include "cprintf.h"

/* LEDS are configured as follows, looking at the stick with the usb
   cable DOWN:

		RED[7:0]  RED[13:8]
		P20..P26  P27,PA0..PA5  LOW = ON
   COM0 PD0
   COM1
   COM2  .
   COM3
   COM4  .

   COM5  .
   COM6
   COM7 PD7
   COM8 PE0  LOW = ON
   COM9 PE1
*/

static volatile int timer = 0;

static void __attribute__((interrupt))
tpu0_handler ()
{
  int dr8 = 0x18;
  timer ++;
}

char banner_message[] = "DJ was here!\n";

main()
{
  int i, j, r, c;

  setbuf(stdout, NULL);

#if 0
  /* Power up the peripherals.  */
  MSTPCRA = 0;
  MSTPCRB = 0;
  MSTPCRC = 0;

  DR[2] = 0x18;
  DR[10] = 0x18;
  DR[13] = 0x12;
  DR[14] = 0x34;

  DDR[2] = 0x18;
  DDR[10] = 0x18;
  DDR[13] = 0xff;
  DDR[14] = 0xff;

  /* Timer */
  _vectors[IVEC_TPU0_TGI0A] = tpu0_handler;
  IER0D |= 0x01;
  IPR4C = 5;

  TPU[0].tcr = 0x20; /* TGRA, PCLK = 25 MHz */
  TPU[0].tier = 0x01; /* interrupt on TGRA */
  TPU[0].tgra = 25000; /* should be 1 mS */

  TSTRA |= 0x01; /* start timer */
#endif


  set_system_clock_speed ();
  setup_interrupts ();

  tty_init ();
  tty_puts(banner_message);

  i = 1;
  if (*(unsigned char *)&i == 1)
    tty_puts("little endian\n");
  else
    tty_puts("big endian\n");

  i = 1;
  while (1)
    {
      int p0, p2, p3, p8;

      for (j=800000; j; j--)
	asm("");

      if (++i == 10*14)
	i = 0;

      r = i / 14;
      c = i % 14;

      DR[13] = 1 << c;
      DR[14] = 1 << (c-8);

      DR[2] = 1 << r;
      DR[10] = 1 << (r-8);
    }

  tty_putc_port (3, 4);
  tty_putc_port (3, 4);
  tty_putc_port (0, 4);

  while (1)
    {
    }
}
